## jetty-extensions
Extensions for Jetty web server.  
TLSContextFactory: Jetty 9.3.x extension to retrieve the keystore and truststore directly from S3, instead of the disk, and keep it in memory.  
CertificateRevocationHandler: Jetty handler to deny access of revoked certificates.

## Keystore and truststore
The keystore should contain both the certificate and private key used by Jetty to comunicate with clients.  
The truststore should contain any certificates used to authenticate the clients.  
Both should be in PKCS #12 format.

## How to build
Run `gradle build|shadowJar` to generate the jar in `build/libs/`.

## How to run
The shadowJar of this should be added to Jetty's `lib/ext` directory.  
`start.ini` and some files in `etc/` need to be added/edited.  
OBS.: File `etc/keystore` must exist (can be empty), otherwise Jetty won't start.
