package br.com.nubank.keyper;

import java.security.KeyPair;
import java.security.KeyPairGenerator;
import java.security.PublicKey;
import java.security.spec.X509EncodedKeySpec;
import java.util.Base64;

public class Keys {
    public static KeyPair generate() {
        try {
            KeyPairGenerator keyGen = KeyPairGenerator.getInstance("RSA");
            keyGen.initialize(2048);
            return keyGen.genKeyPair();
        } catch (Exception e) {
            throw new KeyperException(e);
        }
    }

    public static PublicKey from(String pemPublicKey) {
        try {
            pemPublicKey = pemPublicKey.replace("-----BEGIN PUBLIC KEY-----", "");
            pemPublicKey = pemPublicKey.replace("-----END PUBLIC KEY-----", "");
            pemPublicKey = pemPublicKey.replace("\n", "");
            byte[] decoded = Base64.getDecoder().decode(pemPublicKey);
            X509EncodedKeySpec spec = new X509EncodedKeySpec(decoded);
            java.security.KeyFactory kf = java.security.KeyFactory.getInstance("RSA");
            return kf.generatePublic(spec);
        } catch (Exception e) {
            throw new KeyperException(e);
        }
    }

    protected static String toPem(PublicKey publicKey) {
        byte[] keyBytes = publicKey.getEncoded();
        String header = "-----BEGIN PUBLIC KEY-----\n";
        String footer = "\n-----END PUBLIC KEY-----";
        String base64PublicKey = new String(Base64.getEncoder().encode(keyBytes));
        return header + base64PublicKey + footer;
    }
}