package br.com.nubank.keyper;

import java.io.ByteArrayInputStream;
import java.security.KeyStore;

public class PKCS12 {
    private byte[] pkcs12Bytes;

    public PKCS12(byte[] pkcs12Bytes) {
        this.pkcs12Bytes = pkcs12Bytes;
    }

    public KeyStore toKeyStore() {
        try {
            KeyStore keyStore = KeyStore.getInstance("PKCS12");
            keyStore.load(new ByteArrayInputStream(pkcs12Bytes), Certificates.password);
            return keyStore;
        } catch (Exception e) {
            throw new KeyperException(e);
        }
    }

    public byte[] getBytes() {
        return pkcs12Bytes;
    }
}
